<template>
  <!-- Navbar container -->
  <nav id="_navbar">

    <div id="_navbar-nav">

      <!-- Brand nav -->
      <div id="_navbar-brand">

        <Link to="/" class="flex items-center" no-underline>
          <img src="@/assets/img/logo.png" width="36" height="36" class="-ml-1 mr-1 py-1" alt="logo"/>
          <span class="_font-zeroes-three">{{ GLOBALS.__APP_NAME__ }}</span>
        </Link>

      </div>

      <!-- Menu button (visible if window size < lg-breakpoint) -->
      <div id="_navbar-menu-button">

        <button @click="collapse()">
          <MenuIcon
            width="20"
            :fill="collapsed ? GLOBALS.__THEME_SECONDARY_COLOR__ : GLOBALS.__THEME_PRIMARY_COLOR__"
            :hoverFill="GLOBALS.__THEME_PRIMARY_COLOR__"
            class="transition"
          />
        </button>

      </div>

    </div>

    <!-- Navbar content -->
    <div id="_navbar-collapse" :class="`${ collapsed ? 'collapsed' : ''}`">

      <!-- Left align items -->
      <div class="_navbar-collapse-group">

        <!-- Dashboard link -->
        <div v-if="$root.auth.user()" class="_navbar-item mr-4">
          <Link to="/">
            <v-icon name="laptop" class="mr-2"/>
            <span>{{ $t('views.Dashboard.title') | capitalize }}</span>
          </Link>
        </div>

      </div>

      <!-- Right align items -->
      <div class="_navbar-collapse-group">

        <!-- About link -->
        <div class="_navbar-item">
          <Link to="/about" class="mr-4">
            <v-icon name="question-circle" class="mr-2"></v-icon>{{ $t('views.About.title') | capitalize }}
          </Link>
        </div>

        <!-- User dropdown if navbar is breakpoint > LG -->
        <UserDropdown v-if="$root.auth.user() && format === 'desktop'" class="_navbar-item mr-4"/>

        <!-- Extract user dropdown links individually when 'compact format' -->
        <div v-if="$root.auth.user() && format === 'compact'" class="_navbar-item">
          <Link to="/settings">
            <v-icon name="cog" class="mr-2"/>
            <span>{{ $t('views.Settings.Index.title') | capitalize }}</span>
          </Link>
        </div>
        <div v-if="$root.auth.user() && format === 'compact'" class="_navbar-item">
          <v-icon name="sign-out-alt" class="mr-2"/>
          <span class="cursor-pointer" @click="$root.auth.logout()">{{ $t('user.logout') | capitalize }}</span>
        </div>

        <!-- Login link -->
        <div v-if="!$root.auth.user()" class="_navbar-item">
          <Link to="/login" class="mr-4">
            {{ $t('user.signIn') | capitalize }}
          </Link>
        </div>

      </div>

    </div>

  </nav>

</template>

<script>
import UserDropdown from './UserDropdown'
// Utils
import { isDef } from '#utils'
/**
 * Navbar partial component
 */
export default {
  name: 'Navbar',
  components: {
    UserDropdown
  },
  data () {
    return {
      format: 'desktop', // 'desktop' or 'compact' (mobile, tablet, etc...)
      collapsed: true
    }
  },
  methods: {
    collapse (value) {
      const to = isDef(value) ? value : !this.collapsed
      if (to !== this.collapsed) {
        this.collapsed = to
      }
    }
  },
  mounted () {
    // Auto collapse at mounted
    if (this.$root.ui.currentBreakpoint().width >= __THEME_BREAKPOINTS_LG__) {
      this.format = 'desktop'
      this.collapse(false)
    } else {
      this.format = 'compact'
      this.collapse(true)
    }
    // Auto collapse when window resize (based on 'lg' breakpoint)
    this.$root.on('BREAKPOINT_CHANGED', (breakpoint) => {
      if (breakpoint.width >= __THEME_BREAKPOINTS_LG__) {
        this.format = 'desktop'
        this.collapse(false)
      } else {
        this.format = 'compact'
        this.collapse(true)
      }
    })
  }
}
</script>

<style lang="scss">
  #_navbar {
    @apply w-full;
    @apply flex flex-wrap;
    @apply dark:bg-dark-2;

    #_navbar-nav {
      @apply flex justify-between items-center;
      @apply w-full;
      @apply px-4 py-1.5;
      @apply lg:w-auto;

      #_navbar-brand {
        //
      }

      #_navbar-menu-button {
        @apply flex;
        @apply items-center;
        @apply px-3;
        @apply lg:hidden; // (visible if window size < lg-breakpoint)
      }
    }

    #_navbar-collapse {
      @apply flex flex-grow flex-wrap flex-col justify-between;
      @apply relative;
      @apply top-0;
      @apply px-4 py-1.5;
      @apply lg:flex-nowrap;
      @apply lg:flex-row;
      @apply lg:items-center;
      @apply lg:h-auto;

      ._navbar-collapse-group {
        @apply flex;
        @apply flex-col;
        @apply lg:flex-row;
        @apply lg:items-center;

        ._navbar-item {
          @apply py-2;
          @apply h-auto;
          @apply lg:py-0;
        }
      }

      &.collapsed {
        @apply hidden;
      }
    }
  }
</style>
